/*     */ package org.apache.batik.extension;
/*     */ 
/*     */ import org.apache.batik.css.engine.CSSStylableElement;
/*     */ import org.apache.batik.css.engine.StyleDeclarationProvider;
/*     */ import org.apache.batik.css.engine.StyleMap;
/*     */ import org.apache.batik.dom.AbstractDocument;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.css.CSSStyleDeclaration;
/*     */ import org.w3c.dom.css.CSSValue;
/*     */ import org.w3c.dom.svg.SVGAnimatedString;
/*     */ import org.w3c.dom.svg.SVGStylable;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class StylableExtensionElement
/*     */   extends ExtensionElement
/*     */   implements CSSStylableElement, SVGStylable
/*     */ {
/*     */   protected ParsedURL cssBase;
/*     */   protected StyleMap computedStyleMap;
/*     */   
/*     */   protected StylableExtensionElement() {}
/*     */   
/*  69 */   protected StylableExtensionElement(String name, AbstractDocument owner) { super(name, owner); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  78 */   public StyleMap getComputedStyleMap(String pseudoElement) { return this.computedStyleMap; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  85 */   public void setComputedStyleMap(String pseudoElement, StyleMap sm) { this.computedStyleMap = sm; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  92 */   public String getXMLId() { return getAttributeNS(null, "id"); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  99 */   public String getCSSClass() { return getAttributeNS(null, "class"); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ParsedURL getCSSBase() {
/* 106 */     if (this.cssBase == null) {
/* 107 */       String bu = getBaseURI();
/* 108 */       if (bu == null) {
/* 109 */         return null;
/*     */       }
/* 111 */       this.cssBase = new ParsedURL(bu);
/*     */     } 
/* 113 */     return this.cssBase;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean isPseudoInstanceOf(String pseudoClass) {
/* 121 */     if (pseudoClass.equals("first-child")) {
/* 122 */       Node n = getPreviousSibling();
/* 123 */       while (n != null && n.getNodeType() != 1) {
/* 124 */         n = n.getPreviousSibling();
/*     */       }
/* 126 */       return (n == null);
/*     */     } 
/* 128 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 137 */   public StyleDeclarationProvider getOverrideStyleDeclarationProvider() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 146 */   public CSSStyleDeclaration getStyle() { throw new UnsupportedOperationException("Not implemented"); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 154 */   public CSSValue getPresentationAttribute(String name) { throw new UnsupportedOperationException("Not implemented"); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 162 */   public SVGAnimatedString getClassName() { throw new UnsupportedOperationException("Not implemented"); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-extension.jar!\org\apache\batik\extension\StylableExtensionElement.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */