/*     */ package org.apache.batik.extension.svg;
/*     */ 
/*     */ import org.apache.batik.dom.AbstractDocument;
/*     */ import org.apache.batik.dom.DomExtension;
/*     */ import org.apache.batik.dom.ExtensibleDOMImplementation;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BatikDomExtension
/*     */   implements DomExtension, BatikExtConstants
/*     */ {
/*  45 */   public float getPriority() { return 1.0F; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  52 */   public String getAuthor() { return "Thomas DeWeese"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  59 */   public String getContactAddress() { return "deweese@apache.org"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  67 */   public String getURL() { return "http://xml.apache.org/batik"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  76 */   public String getDescription() { return "Example extension to standard SVG shape tags"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void registerTags(ExtensibleDOMImplementation di) {
/*  89 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "regularPolygon", new BatikRegularPolygonElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  94 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "star", new BatikStarElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  99 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "histogramNormalization", new BatikHistogramNormalizationElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 104 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "colorSwitch", new ColorSwitchElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 109 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowText", new FlowTextElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 114 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowDiv", new FlowDivElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 119 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowPara", new FlowParaElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 124 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowRegionBreak", new FlowRegionBreakElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 129 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowRegion", new FlowRegionElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 134 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowLine", new FlowLineElementFactory());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 139 */     di.registerCustomElementFactory("http://xml.apache.org/batik/ext", "flowSpan", new FlowSpanElementFactory());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class BatikRegularPolygonElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 155 */     public Element create(String prefix, Document doc) { return new BatikRegularPolygonElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class BatikStarElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 171 */     public Element create(String prefix, Document doc) { return new BatikStarElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class BatikHistogramNormalizationElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 185 */     public Element create(String prefix, Document doc) { return new BatikHistogramNormalizationElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class ColorSwitchElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 201 */     public Element create(String prefix, Document doc) { return new ColorSwitchElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowTextElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 216 */     public Element create(String prefix, Document doc) { return new FlowTextElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowDivElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 231 */     public Element create(String prefix, Document doc) { return new FlowDivElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowParaElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 246 */     public Element create(String prefix, Document doc) { return new FlowParaElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowRegionBreakElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 261 */     public Element create(String prefix, Document doc) { return new FlowRegionBreakElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowRegionElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 276 */     public Element create(String prefix, Document doc) { return new FlowRegionElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowLineElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 291 */     public Element create(String prefix, Document doc) { return new FlowLineElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class FlowSpanElementFactory
/*     */     implements ExtensibleDOMImplementation.ElementFactory
/*     */   {
/* 306 */     public Element create(String prefix, Document doc) { return new FlowSpanElement(prefix, (AbstractDocument)doc); }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-extension.jar!\org\apache\batik\extension\svg\BatikDomExtension.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */