/*    */ package org.apache.batik.extension;
/*    */ 
/*    */ import org.apache.batik.dom.AbstractDocument;
/*    */ import org.apache.batik.dom.util.DOMUtilities;
/*    */ import org.w3c.dom.DOMException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class PrefixableStylableExtensionElement
/*    */   extends StylableExtensionElement
/*    */ {
/* 37 */   protected String prefix = null;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   protected PrefixableStylableExtensionElement() {}
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public PrefixableStylableExtensionElement(String prefix, AbstractDocument owner) {
/* 52 */     super(prefix, owner);
/* 53 */     setPrefix(prefix);
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/* 60 */   public String getNodeName() { return (this.prefix == null || this.prefix.equals("")) ? getLocalName() : (this.prefix + ':' + getLocalName()); }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public void setPrefix(String prefix) throws DOMException {
/* 68 */     if (isReadonly()) {
/* 69 */       throw createDOMException((short)7, "readonly.node", new Object[] { new Integer(getNodeType()), getNodeName() });
/*    */     }
/*    */ 
/*    */ 
/*    */     
/* 74 */     if (prefix != null && !prefix.equals("") && !DOMUtilities.isValidName(prefix))
/*    */     {
/*    */       
/* 77 */       throw createDOMException((short)5, "prefix", new Object[] { new Integer(getNodeType()), getNodeName(), prefix });
/*    */     }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */     
/* 84 */     this.prefix = prefix;
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-extension.jar!\org\apache\batik\extension\PrefixableStylableExtensionElement.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */