/*    */ package org.apache.batik.extension.svg;
/*    */ 
/*    */ import java.text.AttributedCharacterIterator;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Iterator;
/*    */ import java.util.List;
/*    */ import org.apache.batik.gvt.TextNode;
/*    */ import org.apache.batik.gvt.TextPainter;
/*    */ import org.apache.batik.gvt.renderer.StrokingTextPainter;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class FlowExtTextPainter
/*    */   extends StrokingTextPainter
/*    */ {
/* 44 */   protected static TextPainter singleton = new FlowExtTextPainter();
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/* 50 */   public static TextPainter getInstance() { return singleton; }
/*    */ 
/*    */   
/*    */   public List getTextRuns(TextNode node, AttributedCharacterIterator aci) {
/* 54 */     List textRuns = node.getTextRuns();
/* 55 */     if (textRuns != null) {
/* 56 */       return textRuns;
/*    */     }
/*    */     
/* 59 */     AttributedCharacterIterator[] chunkACIs = getTextChunkACIs(aci);
/* 60 */     textRuns = computeTextRuns(node, aci, chunkACIs);
/*    */     
/* 62 */     aci.first();
/* 63 */     List rgns = (List)aci.getAttribute(StrokingTextPainter.FLOW_REGIONS);
/*    */     
/* 65 */     if (rgns != null) {
/* 66 */       Iterator i = textRuns.iterator();
/* 67 */       List chunkLayouts = new ArrayList();
/* 68 */       StrokingTextPainter.TextRun tr = (StrokingTextPainter.TextRun)i.next();
/* 69 */       List layouts = new ArrayList();
/* 70 */       chunkLayouts.add(layouts);
/* 71 */       layouts.add(tr.getLayout());
/* 72 */       while (i.hasNext()) {
/* 73 */         tr = (StrokingTextPainter.TextRun)i.next();
/* 74 */         if (tr.isFirstRunInChunk()) {
/* 75 */           layouts = new ArrayList();
/* 76 */           chunkLayouts.add(layouts);
/*    */         } 
/* 78 */         layouts.add(tr.getLayout());
/*    */       } 
/*    */       
/* 81 */       FlowExtGlyphLayout.textWrapTextChunk(chunkACIs, chunkLayouts, rgns);
/*    */     } 
/*    */ 
/*    */     
/* 85 */     node.setTextRuns(textRuns);
/* 86 */     return textRuns;
/*    */   }
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-extension.jar!\org\apache\batik\extension\svg\FlowExtTextPainter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */